VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGIFanimator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'--- clsGIFanimator used to display animated gifs -----
'
'   Copyright (C) 2005  William Moeur
'   This program is free software; you can redistribute it and/or modify it
'
' Example of usage:
'   Dim WithEvents GIFani As clsGIFanimator
'   Set GIFani = New clsGIFanimator
'   With GIFani
'        .xLeft = 0
'       .yTop = 0
'        .AutoSize = True
'       '3 ways to load image
'        'from file
'       ' .LoadGif Me, "heli.gif"
'       'from resource
'       .LoadGif Me, LoadResData(101, "CUSTOM")
'       'using resource number, assumes data is in "CUSTOM"
'       ' .LoadGif Me, 101
'       Timer1.Interval = .DisplayFrame(0)
'       Timer1.Enabled = True
'   End With
'
'   Private Sub Timer1_Timer()
'   Static iFrame As Integer
'       Timer1.Interval = GIFani.DisplayFrame(iFrame)
'   End Sub
'----------------------------------------------------------

'local variable(s) to hold property value(s)
Private mvarFileName As String 'local copy
Private mvarFrameCount As Integer 'local copy
Private mvarxWidth As Integer 'local copy
Private mvaryHeight As Integer 'local copy
Private mvarAutoSize As Boolean 'local copy
Private mvarComments As String
Dim mVersion As String
Dim m_isTransparent As Boolean
Dim mvarGraphicsDevice As Object

'------------ Local Variables -----------------------
Private arrayFrameData() As FrameData
Private GlobalColorMap() As rgbColor
Private mBackColor As Long
Private mvarBackColor As Long
Private mRepeattimes As Long
Private isRunning As Boolean
Private mSignature As String
Private mLSD As LSD
Private mColorMapSize As Integer
Private mGCE As GCE
Private mCurrentFrame As Integer

'Default Property Values:
Const m_def_isTransparent = False

'Event Declarations:
Public Event GIFError(ByVal Description As String)
Public Event frameChange(ByVal Index As Integer)

' -------- GDI Declarations --------------------------
Private Declare Function BitBlt Lib "gdi32" ( _
    ByVal hDestDC As Long, _
    ByVal X As Long, _
    ByVal Y As Long, _
    ByVal nWidth As Long, _
    ByVal nHeight As Long, _
    ByVal hSrcDC As Long, _
    ByVal Xsrc As Long, _
    ByVal Ysrc As Long, _
    ByVal dwRop As Long _
) As Long

Private Declare Function TransparentBlt Lib "msimg32.dll" ( _
    ByVal hDestDC As Long, _
    ByVal xdest As Long, _
    ByVal ydest As Long, _
    ByVal destWidth As Long, _
    ByVal destHeight As Long, _
    ByVal hSrcDC As Long, _
    ByVal Xsrc As Long, _
    ByVal Ysrc As Long, _
    ByVal srcWidth As Long, _
    ByVal srcHeight As Long, _
    ByVal crTransparent As Long _
) As Long

Private Declare Function CreateDC Lib "gdi32" Alias "CreateDCA" ( _
    ByVal lpDriverName As String, _
    ByVal lpDeviceName As String, _
    ByVal lpOutput As String, _
    ByVal lpInitData As Long _
) As Long

Private Declare Function CreateCompatibleBitmap Lib "gdi32" ( _
    ByVal hDc As Long, _
    ByVal nWidth As Long, _
    ByVal nHeight As Long _
) As Long

Private Declare Function CreateCompatibleDC Lib "gdi32" ( _
    ByVal hDc As Long _
) As Long

Private Declare Function DeleteDC Lib "gdi32" ( _
    ByVal hDc As Long _
) As Long

Private Declare Function SelectObject Lib "gdi32" ( _
    ByVal hDc As Long, ByVal hObject As Long _
) As Long

Private Declare Function GetWindowDC Lib "user32" ( _
    ByVal hWnd As Long _
) As Long

Private Declare Function GetWindowRect Lib "user32" ( _
    ByVal hWnd As Long, _
    lpRect As RECT _
) As Long

Private Declare Function GetClientRect Lib "user32" ( _
    ByVal hWnd As Long, _
    lpRect As RECT _
) As Long

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Declare Function FillRect Lib "user32" ( _
    ByVal hDc As Long, _
    lpRect As RECT, _
    ByVal hBrush As Long _
) As Long

Private Declare Function CreateSolidBrush Lib "gdi32" ( _
    ByVal crColor As Long _
) As Long

Private Declare Function GetSysColorBrush Lib "user32" ( _
    ByVal nIndex As Long _
) As Long

Private Const SRCCOPY = &HCC0020

Private Declare Function DeleteObject Lib "gdi32" ( _
    ByVal hObject As Long _
) As Long



'--------------- Misc API Declarations -----------------------------
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    Destination As Any, _
    Source As Any, _
    ByVal Length As Long _
)

Private Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" ( _
    ByVal dwFlags As Long, _
    lpSource As Any, _
    ByVal dwMessageId As Long, _
    ByVal dwLanguageId As Long, _
    ByVal lpBuffer As String, _
    ByVal nSize As Long, _
    Arguments As Long _
) As Long
'-------------- Local User Defined Types -------------------------
'Logical Screen Descriptor
'only one for entire set of images
Private Type LSD
    Width As Integer
    Height As Integer
    M As Boolean
    CR As Byte
    SortFlag As Boolean
    pixel As Byte
    background As Byte
    AspectRatio As Integer
End Type

'Graphic Control Extension
' one for each image frame
Private Type GCE
    TCI As Byte
    Delaytime As Integer
    DisposalMethod As DisposalMethods
    UserInputFlag As Boolean
    TCflag As Boolean
End Type

'Image Descriptor
'One for each image frame
Private Type ImgDesc
    Left As Integer
    Top As Integer
    Width As Integer
    Height As Integer
    LCTFlag As Boolean
    InterlaceFlag As Boolean
    SortFlag As Boolean
    LCTSize As Byte
End Type

Private Type rgbColor
    Red As Byte
    Green As Byte
    Blue As Byte
End Type

'all data associated with a frame
Private Type FrameData
    hDc As Long
    objPIC As IPictureDisp
    GCE As GCE
    ImageDescriptor As ImgDesc
    ColorMap() As rgbColor
    TransparentColor As Long
End Type


'----------- Local Constants and Enumerations ---------------
'introducer
Private Const EXTENSION As Byte = &H21
'labels
Private Const APPLICATION As Byte = &HFF
Private Const COMMENT As Byte = &HFE
Private Const CONTROL As Byte = &HF9
Private Const PLAINTEXT As Byte = &H1
Private Const TRAILER As Byte = &H3B
Private Const IMAGE_SEPARATOR As Byte = &H44
Private Const IMAGE_DESCRIPTOR As Byte = &H2C
Private Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000
Private Const FORMAT_MESSAGE_IGNORE_INSERTS = &H200

Private Enum DisposalMethods
    dmNONE = 0 'No disposal specified. The decoder is not required
    '       to take any action.
    dmDONOT = 1 'Do not dispose. The graphic is to be left in place.
    dmRESTORE_BKGND = 2 'Restore to background color. The area used
    '      by the graphic must be restored to the background color.
    dmRESTORE_PREVIOUS = 3 'Restore to previous. The decoder is
    '      required to restore the area overwritten by the graphic
    '      with what was there prior to rendering the graphic.
End Enum
'local variable(s) to hold property value(s)
Private mvarxLeft As Integer 'local copy
Private mvaryTop As Integer 'local copy
Private mvarSpeed As Integer 'local copy
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long

Function ImageCount(Buffer() As Byte, ByVal ptr As Long) As Integer
Dim LCTSize As Byte
Dim LCTFlag As Boolean
Dim nbytes As Byte
Dim L As Integer
Dim icount As Integer
    icount = 0
    Do
        If Buffer(ptr + 2) = CONTROL Then
            'Graphic Control Exension
            nbytes = Buffer(ptr + 3)
            ptr = ptr + nbytes + 4
        Else
            'No Control Block
        End If
                
        'check for local comments
        If Buffer(ptr + 2) = COMMENT Then
            nbytes = Buffer(ptr + 3)
            ptr = ptr + nbytes + 4
            While Buffer(ptr) > 0
                ptr = ptr + Buffer(ptr) + 1
            Wend
        
        End If
        
        'after control should be an Image block
        ' IMAGE BLOCK
        If Buffer(ptr + 1) = IMAGE_DESCRIPTOR Then
            LCTSize = SplitBits(Buffer(ptr + 10), 0, 3)
            LCTFlag = ((Buffer(ptr + 10) And 128) = 128)
            
        'LOCAL COLOR TABLE
            If LCTFlag = True Then
                L = 2 ^ (LCTSize + 1)
                ptr = ptr + 3 * L - 1 + 11
            Else
                ptr = ptr + 10
            End If
        
    'IMAGE DATA
        'advance pointer to end of image data
        ptr = AdvancePointer(Buffer, ptr + 2)
        icount = icount + 1
'    Else
 '       If Buffer(ptr + 1) <> TRAILER Then Stop
    End If
    
    Loop While Not Buffer(ptr + 1) = TRAILER
    
    ImageCount = icount

End Function

Function RGB2(Red As Byte, Green As Byte, Blue As Byte) As Long
    RGB2 = Red * &H10000 + Green * &H100& + CLng(Blue)
End Function

Public Property Let Speed(ByVal vData As Integer)
    mvarSpeed = vData
End Property


Public Property Get Speed() As Integer
    Speed = mvarSpeed
End Property



Public Function TransparentColor(Index As Integer) As Long
    If arrayFrameData(Index).GCE.TCflag Then 'is there a transparent color?
        TransparentColor = arrayFrameData(Index).TransparentColor
    Else
        TransparentColor = -1
    End If
End Function

Public Property Let yTop(ByVal vData As Integer)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.yTop = 5
    mvaryTop = vData
End Property


Public Property Get yTop() As Integer
    yTop = mvaryTop
End Property



Public Property Let xLeft(ByVal vData As Integer)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.xLeft = 5
    mvarxLeft = vData
End Property


Public Property Get xLeft() As Integer
    xLeft = mvarxLeft
End Property





Public Function DisplayFrame(iFrame As Integer, Optional FirstTime As Boolean = False) As Integer
Static LastFrame As Integer
Dim myRect As RECT
If mSignature = "" Then Exit Function
If iFrame < 0 Then iFrame = LastFrame
If iFrame > UBound(arrayFrameData) Then iFrame = 0
  If Not FirstTime Then
    With arrayFrameData(iFrame).ImageDescriptor
    'dispose of previous picture in required manner
       Select Case arrayFrameData(iFrame).GCE.DisposalMethod
        Case Is = dmNONE
        Case Is = dmDONOT 'don't dispose of previous image
        Case Is = dmRESTORE_BKGND 'dispose of previous image
         myRect.Left = .Left + xLeft
         myRect.Top = .Top + yTop
         myRect.Bottom = myRect.Top + .Height
         myRect.Right = myRect.Left + .Width
         EraseBackGround iFrame, myRect, mBackColor
        Case Is = dmRESTORE_PREVIOUS
        'not supported
         Stop
       End Select
    End With
      
    LastFrame = iFrame
    If iFrame < UBound(arrayFrameData) Then
         iFrame = iFrame + 1
    Else
         iFrame = 0
    End If
  Else
    iFrame = 0
    Set mvarGraphicsDevice.Picture = LoadPicture
  End If

  With arrayFrameData(iFrame).ImageDescriptor
    If arrayFrameData(iFrame).GCE.TCflag Then
        TransparentBlt mvarGraphicsDevice.hDc, .Left + xLeft, .Top + yTop, .Width, .Height, _
        arrayFrameData(iFrame).hDc, 0, 0, .Width, .Height, mBackColor
    Else
        BitBlt mvarGraphicsDevice.hDc, .Left + xLeft, .Top + yTop, .Width, .Height, _
        arrayFrameData(iFrame).hDc, 0, 0, SRCCOPY
    End If
  End With

'Set mvarGraphicsDevice.Picture = arrayFrameData(iFrame).objPIC
   RaiseEvent frameChange(iFrame)
    DisplayFrame = arrayFrameData(iFrame).GCE.Delaytime * mvarSpeed
    mvarGraphicsDevice.Refresh
End Function

Public Property Get Comments() As String
    Comments = mvarComments
End Property

Private Function AdvancePointer(Buffer() As Byte, ptr As Long) As Long
'returns a pointer to the block terminator
Dim nbytes As Byte
Dim p As Long
    p = ptr
    '1st byte is number of bytes in data block
    nbytes = Buffer(p)
    While nbytes > 0
        'point to next block
        p = p + nbytes + 1
        nbytes = Buffer(p)
    Wend
    AdvancePointer = p
End Function

Private Function BytesToInteger(Buffer As Byte) As Integer
    CopyMemory BytesToInteger, Buffer, 2
End Function

Private Function BytesToString(Buffer As Byte, Length As Long) As String

BytesToString = String(Length, 0)
CopyMemory ByVal BytesToString, Buffer, Length

End Function

Private Sub EraseBackGround(iFrame As Integer, myRect As RECT, ByVal fillColor As Long)
Dim hbrBkgnd As Long
        If fillColor And &H80000000 Then
            hbrBkgnd = GetSysColorBrush(fillColor And &HFFFFFF)
        Else
            hbrBkgnd = CreateSolidBrush(fillColor)
        End If
        Call FillRect(mvarGraphicsDevice.hDc, myRect, hbrBkgnd)
End Sub

Private Function GetColorTable(Buffer() As Byte, ByVal ptr As Long, ByVal lenTable As Byte, Table() As rgbColor) As Long
    Dim L As Long
    L = 2 ^ (lenTable + 1)
    ReDim Table(0 To L - 1)
    CopyMemory Table(0), Buffer(ptr), 3 * L
    GetColorTable = ptr + 3 * L - 1
End Function

Public Function Frame(Index As Integer, xWidth As Integer, yHeight As Integer) As IPictureDisp
    With arrayFrameData(Index)
        xWidth = .ImageDescriptor.Width
        yHeight = .ImageDescriptor.Height
        Set Frame = arrayFrameData(Index).objPIC
    End With
End Function


Private Function SplitBits(ByVal X As Byte, Startbit As Byte, nBits As Byte) As Byte

'shift x right startbits times
    X = X \ (2 ^ Startbit)
'mask off top end
    SplitBits = X And (2 ^ nBits - 1)

End Function

Public Property Get yHeight() As Integer
    yHeight = mvaryHeight
End Property

Public Property Get xWidth() As Integer
    xWidth = mvarxWidth
End Property

Public Property Get FrameCount() As Integer
    FrameCount = mvarFrameCount
End Property


Public Property Get FileName() As String
    FileName = mvarFileName
End Property

Public Property Get picFrame(Index As Integer, Optional picLeft As Integer, Optional picTop As Integer) As IPictureDisp

    If Index > UBound(arrayFrameData) Then Index = 0

    Set picFrame = arrayFrameData(Index).objPIC

    picLeft = arrayFrameData(Index).ImageDescriptor.Left
    picTop = arrayFrameData(Index).ImageDescriptor.Top
    Index = Index + 1
End Property

Private Function GetAPIErrorText(ByVal lError As Long) As String
Dim sOut As String
Dim sMsg As String
Dim lret As Long
    GetAPIErrorText = ""
    sMsg = String(256, 0)
    lret = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM Or FORMAT_MESSAGE_IGNORE_INSERTS, _
        0&, lError, 0&, sMsg, Len(sMsg), 0&)
    sOut = lError & " (&H" & Hex(lError) & "): "
    If lret <> 0 Then
        sMsg = Trim(sMsg)
        If Right(sMsg, 2) = vbCrLf Then sMsg = Left(sMsg, Len(sMsg) - 2)
        sOut = sOut & Trim(sMsg)
    Else
        sOut = "<no such error>"
    End If
    GetAPIErrorText = sOut
End Function

Public Function LoadGIF(objPIC As Object, Resource As Variant) As Boolean
    Dim ptr As Long
    Dim Buffer() As Byte
    Dim nbytes As Byte
    Dim startptr As Long
    Dim stopptr As Long
    Dim hbrBkgnd As Long
    Dim myRect As RECT
    Dim mFrameData As FrameData
    
    Dim fnum As Integer
    Dim char As String * 1
    Dim oneByte As Byte
    Dim imgHeader As String, fileHeader As String
    Dim i As Long
    Dim picbuf As String
    Dim Index As Byte
    Dim BorderWidth As Integer
    Dim BorderHeight As Integer
    LoadGIF = False

    If VarType(Resource) = vbString Then 'load gif from file
        'see if file exists
        If Dir$(Resource) = "" Or Resource = "" Then
            RaiseEvent GIFError("File Does Not Exist.")
            Exit Function
        End If
        mvarFileName = Resource
        fnum = FreeFile
        Open mvarFileName For Binary Access Read As fnum
            ReDim Buffer(0 To LOF(fnum) - 1)
            Get #fnum, , Buffer 'Get contents of GIF File into buffer
        Close fnum
    ElseIf VarType(Resource) = vbByte + vbArray Then 'data already in array
        Buffer = Resource
    Else 'try loading from resource file
        Buffer = LoadResData(Resource, "CUSTOM")
    End If

'-----------------------------------------------------------------
'GENERAL FILE FORMAT
'
'        +-----------------------+
'        | +-------------------+ |
'        | |   GIF Signature   | | 6 bytes
'        | +-------------------+ |
'        | +-------------------+ |
'        | | Screen Descriptor | | 7 bytes
'        | +-------------------+ |
'        | +-------------------+ |
'        | | Global Color Map  | | 2^pixel bytes
'        | +-------------------+ |
'        . . .               . . .
'        | +-------------------+ |    ---+
'        | |  Image Descriptor | |       |
'        | +-------------------+ |       |
'        | +-------------------+ |       |
'        | |  Local Color Map  | |       |-   Repeated 1 to n times
'        | +-------------------+ |       |
'        | +-------------------+ |       |
'        | |    Raster Data    | |       |
'        | +-------------------+ |    ---+
'        . . .               . . .
'        |-    GIF Terminator   -|
'        +-----------------------+
'-----------------------------------------------------------------

' GIF Signature
'The HEADER block is a small 6-byte (6-character) block. It is the first block in
'every file and contains the GIF version of the file (i.e either GIF87a or GIF89a). '
'GIF image decoders use this information to determine the version of the file.

'look for tag declaring GIF file
    mSignature = BytesToString(Buffer(0), 3)
    If mSignature <> "GIF" Then
       RaiseEvent GIFError("Not a gif file: File format is not supported.")
       Exit Function
    End If

    mVersion = BytesToString(Buffer(3), 3)
    If mVersion <> "89a" Then
        'RaiseEvent GIFError("GIF version " & mVersion & " is not supported.")
        'Exit Function
    End If
' BLOCK #2 LOGICAL SCREEN DESCRIPTOR

'The LOGICAL SCREEN DESCRIPTOR
'defines an area of pixels which you can think of as a screen.
'The dimensions of this area define the size of your GIF on screen.
'The Logical Screen Block also chooses one of the colors in the Global
'Color Table to be the Background color of the screen.
'The Logical Screen Header can also contain the aspect ratio of the image

'Screen Descriptor - 7 bytes
' 1/2 - Width LSB/MSB
' 3/4 - Height LSB/MSB
' 5 - Pixel (0-2) - pixel+1 = # bits/pixel in image.
'      The value of 'pixel' also defines the maximum number of colors within an image
' 5 - SortFlag (3) - if true then color table is sorted
' 5 - cr (4-6) - cr+1 = # bits of color resolution
' 5 - M (7) - M = 1, Global color map follows Descriptor
' 6 - Background = Color index of screen background color
' 7 - Pixel Aspect Ratio - pixel width/pixel height: Aspect ratio =
'      (Pixel Aspect Ratio + 15) / 64

With mLSD
    .Width = BytesToInteger(Buffer(6))
    mvarxWidth = .Width
    .Height = BytesToInteger(Buffer(8))
    mvaryHeight = .Height
    .pixel = SplitBits(Buffer(10), 0, 3)
    .SortFlag = ((Buffer(10) And &H8) = &H8)
    .CR = SplitBits(Buffer(10), 4, 3)
    .M = ((Buffer(10) And &H80) = &H80)
    .background = Buffer(11)
    .AspectRatio = Buffer(12)

'GLOBAL COLOR MAP
' Block #3 Global Color Map(optional)M=1
'size of color map is 3*2^bitsperPixel colors
    If .M = True Then
        ptr = GetColorTable(Buffer(), ptr + 13, .pixel, GlobalColorMap)
        
        mColorMapSize = 2 ^ (.pixel + 1)
        If .background < mColorMapSize Then
            mBackColor = RGB2(GlobalColorMap(.background).Red, _
             GlobalColorMap(.background).Green, GlobalColorMap(.background).Blue)
            mvarBackColor = RGB(GlobalColorMap(.background).Red, _
             GlobalColorMap(.background).Green, GlobalColorMap(.background).Blue)
             objPIC.BackColor = mvarBackColor
        End If
    Else 'no global color map
        ptr = ptr + 12
    End If
        Set objPIC.Picture = LoadPicture

End With

'GIF EXTENSION BLOCKS
' 1 - Introducer(marker) = &H21
' 2 - Function Code
' 3 - byte count (n)
'n bytes of data
'byte count
'n bytes of data
'.....
'0 byte count - terminator

'************************************************************
'get any global extensions that exist
mvarComments = ""
Do

    Select Case Buffer(ptr + 2) ' label
    
    Case Is = APPLICATION
    
        nbytes = Buffer(ptr + 3)

        'see if this is the NETSCAPE Loop extension
        If nbytes = &HB Then
            If BytesToString(Buffer(ptr + 4), 11) = "NETSCAPE2.0" Then
            'NETSCAPE LOOP APPLICATION EXTENSION
            ' 1 - Extension Introducer = &h21
            ' 2 - Application Label = &HFF
            ' 3 - Length of block = &H0B
            ' 4-14 - "NETSCAPE2.0"
            ' 15 - length of data subblock &H3
            ' 16 - &H1
            ' 17/18 - Number of iterations (LSB/MSB)
            ' 19 - Terminator &H00
                'get Number of iterations
                mRepeattimes = Buffer(ptr + 17) + Buffer(ptr + 18) * &H100
                ptr = ptr + 19
            Else
            'APPLICATION EXTENSION
            ' 1 - Extension Introducer = &h21
            ' 2 - Application Label = &HFF
            ' Bytes in data block
            'data
            'Block Terminator = 0
            'skip this extension
                ptr = ptr + nbytes + 4
                While Buffer(ptr) > 0
                    ptr = ptr + Buffer(ptr) + 1
                    Debug.Print "UNKNOWN APPLICATION EXTENSION"
                Wend
            End If
        End If
    
    Case Is = COMMENT
    'COMMENT EXTENSION
    ' 1 - Extension Introducer = &h21
    ' 2 - Comment Label = &HFE
    ' 3 - byte count (n)
    'n bytes of data
    'byte count
    'n bytes of data - 1 to 255 characters of comment
    '.....
    '0 byte count - terminator
        nbytes = Buffer(ptr + 3)
'        Debug.Print "Comment: "; BytesToString(Buffer(ptr + 4), CLng(nbytes))
        ptr = ptr + nbytes + 4
        While Buffer(ptr) > 0
            mvarComments = mvarComments & BytesToString(Buffer(ptr + 1), _
                CLng(Buffer(ptr))) & vbCrLf
            ptr = ptr + Buffer(ptr) + 1
        Wend
        
    Case Is = PLAINTEXT
    'PLAIN TEXT EXTENSION
    ' 1 - Extension Introducer = &h21
    ' 2 - Plain Text Label = 1
    ' 3 - Number of bytes in data section
    ' .....
    '  data
    ' ....
    ' Block Terminator = 0
        Stop
    Case Is = CONTROL
        Exit Do
    Case Else
        Exit Do
    End Select

Loop While Buffer(ptr + 1) = EXTENSION
'**********************************************************************

    fileHeader = BytesToString(Buffer(0), ptr + 1)
    'get number of images in file
    mvarFrameCount = ImageCount(Buffer, ptr)
    If mvarFrameCount = 0 Then Exit Function
    On Error Resume Next
    For i = 0 To UBound(arrayFrameData)
        If arrayFrameData(i).hDc Then DeleteDC arrayFrameData(i).hDc
        Set arrayFrameData(i).objPIC = Nothing
    Next i
    On Error GoTo 0
    ReDim arrayFrameData(0 To mvarFrameCount - 1)
    objPIC.AutoRedraw = True

For i = 0 To mvarFrameCount - 1
        startptr = ptr + 1
        
        If Buffer(ptr + 2) = CONTROL Then
            'Graphic Control Exension
            ' may precede each image
            ' 1 - Extension Introducer = &h21
            ' 2- Graphic control label = &hF9
            ' 3 - Block Size
            ' 4(0) - Transparent Color Flag
            ' 4(1) - User Input Flag: 1=user input is expected before continuing
            ' 4(2-4) - Disposal Method
            ' 5/6 - Delay time: if >0 then specifies number of 1/100 seconds to wait before continuing
            '                    after the graphic has been rendered
            ' 7 - Transparent Color Index: 1=Transparent Index is given
            ' 8 - Block Terminator=0: marks end of graphic control extension

            '  Disposal methods
            '   0 -   No disposal specified. The decoder is not required to take any action.
            '   1 -   Do not dispose. The graphic is to be left in place.
            '   2 -   Restore to background color. The area used by the graphic must be restored
            '          to the background color.
            '   3 -   Restore to previous. The decoder is required to restore the area overwritten
            '          by the graphic with what was there prior to rendering the graphic.
            '   4-7 -    To be defined.
            nbytes = Buffer(ptr + 3)
            
            With arrayFrameData(i).GCE
                .TCI = Buffer(ptr + 7) 'transparency color index
                
                .Delaytime = BytesToInteger(Buffer(ptr + 5))
                .DisposalMethod = SplitBits(Buffer(ptr + 4), 2, 3)
                .TCflag = ((Buffer(ptr + 4) And 1) = 1)
                .UserInputFlag = ((Buffer(ptr + 4) And 2) = 2)
            End With
            ptr = ptr + nbytes + 4
            
            Else
            'No Control Block
            With arrayFrameData(i).GCE
                .TCI = Buffer(ptr + 7)
                .Delaytime = 1
                .DisposalMethod = dmNONE
                .TCflag = False
                .UserInputFlag = False
            End With
        End If
                
        'check for local comments
        If Buffer(ptr + 2) = COMMENT Then
            nbytes = Buffer(ptr + 3)
            
            'Debug.Print "Comment: "; BytesToString(Buffer(ptr + 3), CLng(nbytes))
            ptr = ptr + nbytes + 4
            While Buffer(ptr) > 0
                mvarComments = mvarComments & BytesToString(Buffer(ptr + 1), CLng(Buffer(ptr))) & vbCrLf
                ptr = ptr + Buffer(ptr) + 1
            Wend
        End If
        
        'after control should be an Image block
        ' IMAGE BLOCK

        ' IMAGE DESCRIPTOR
        ' 1 - separator = &h2C
        ' 2/3 - Left LSB/MSB
        ' 4/5 - Top LSB/MSB
        ' 6/7 - Width LSB/MSB
        ' 8/9 - Height LSB/MSB
        ' 10 (0-2)Pixel - # bits per pixel for this image
        ' 10 (5) Sort Flag
        ' 10 (6)I - 1=Interlaced, 0=sequential
        ' 10 (7)M - 0=Use global color map, ignore 'pixel': 1=Local color map follows, use 'pixel'
        
        If Buffer(ptr + 1) = IMAGE_DESCRIPTOR Then
        With arrayFrameData(i).ImageDescriptor
            .Left = BytesToInteger(Buffer(ptr + 2))
            .Top = BytesToInteger(Buffer(ptr + 4))
            .Width = BytesToInteger(Buffer(ptr + 6))
            .Height = BytesToInteger(Buffer(ptr + 8))
            .LCTSize = SplitBits(Buffer(ptr + 10), 0, 3)
            .SortFlag = ((Buffer(ptr + 10) And 32) = 32)
            .InterlaceFlag = ((Buffer(ptr + 10) And 64) = 64)
            .LCTFlag = ((Buffer(ptr + 10) And 128) = 128)
            
        'LOCAL COLOR TABLE
            If .LCTFlag = True Then
                ptr = GetColorTable(Buffer, ptr + 11, .LCTSize, arrayFrameData(i).ColorMap)
            Else
                ptr = ptr + 10
            End If
        End With
        
'set transparent color
        With arrayFrameData(i)
            If .GCE.TCflag Then 'is there a transparency color?
'                Index = .GCE.TCI
'                If .ImageDescriptor.LCTFlag Then 'local color table?
'                    .TransparentColor = RGB2(.ColorMap(Index).Red, .ColorMap(Index).Green, .ColorMap(Index).Blue)
'                Else 'or global color table
'                    .TransparentColor = RGB2(GlobalColorMap(Index).Red, GlobalColorMap(Index).Green, GlobalColorMap(Index).Blue)
'                End If
'NOTE: it seems that backcolor is used as transparent color
                .TransparentColor = mBackColor
            Else
                
            End If
        End With

    'IMAGE DATA
        '1 - LZW code Size
        '2 - Block Size
        '3 - n data
        'blocksize
        'data
        '...
        'Block Terminator = 0
        
        'advance pointer to end of image data
        ptr = AdvancePointer(Buffer, ptr + 2)
        stopptr = ptr
    '*** End of image data

      'output frame to temporary file
        fnum = FreeFile
        Open "temp.gif" For Binary As fnum
            picbuf = fileHeader & BytesToString(Buffer(startptr), stopptr - startptr + 1) & Chr(&H3B)
            Put #fnum, 1, picbuf
        Close fnum
'load picture and delete temp file

        Set arrayFrameData(i).objPIC = LoadPicture("temp.gif")
        Set objPIC.Picture = LoadPicture("temp.gif")
        Kill ("temp.gif")

'create new DC compatible with the graphic Device
            arrayFrameData(i).hDc = CreateCompatibleDC(objPIC.hDc)
'associate bitmap with DC
'use graphics device as temp storage
        SelectObject arrayFrameData(i).hDc, objPIC.Picture.Handle
        hbrBkgnd = CreateSolidBrush(mBackColor)
        myRect.Left = 0
        myRect.Top = 0
        myRect.Right = arrayFrameData(i).ImageDescriptor.Width
        myRect.Bottom = arrayFrameData(i).ImageDescriptor.Height

        Call FillRect(arrayFrameData(i).hDc, myRect, hbrBkgnd)
        DeleteObject hbrBkgnd
  
  With arrayFrameData(i).ImageDescriptor
    If arrayFrameData(i).GCE.TCflag Then
        TransparentBlt arrayFrameData(i).hDc, 0, 0, .Width, .Height, _
        objPIC.hDc, 0, 0, .Width, .Height, mBackColor
    Else
        BitBlt arrayFrameData(i).hDc, 0, 0, .Width, .Height, _
        objPIC.hDc, 0, 0, SRCCOPY
    End If
  End With
        
        If Buffer(ptr + 1) = &H3B Then
            ReDim Preserve arrayFrameData(0 To i)
            mvarFrameCount = i + 1
            Exit For
        End If
     End If
    Next i
            
    LoadGIF = True
    Set mvarGraphicsDevice = objPIC
End Function

Public Property Get BackColor() As OLE_COLOR
    BackColor = mvarBackColor
End Property

Public Property Get isTransparent(Index As Integer) As Boolean
    isTransparent = arrayFrameData(Index).GCE.TCflag
End Property

Public Property Get Version() As String
    Version = mVersion
End Property

Private Sub Class_Initialize()
    mvarSpeed = 10
    mvarAutoSize = False
End Sub

Private Sub Class_Terminate()
    Dim i As Integer
    isRunning = False
On Error GoTo SkipThis
    For i = 0 To UBound(arrayFrameData)
        DeleteDC arrayFrameData(i).hDc
    Next i
SkipThis:
End Sub
